Index: /trunk/SophyaExt/XephemAstroLib/plans.c
===================================================================
--- /trunk/SophyaExt/XephemAstroLib/plans.c	(revision 2550)
+++ /trunk/SophyaExt/XephemAstroLib/plans.c	(revision 2551)
@@ -5,12 +5,11 @@
 #include <math.h>
 
-#include "P_.h"
 #include "astro.h"
 #include "vsop87.h"
 #include "chap95.h"
 
-static void pluto_ell P_((double mjd, double *ret));
-static void chap_trans P_((double mjd, double *ret));
-static void planpos P_((double mjd, int obj, double prec, double *ret));
+static void pluto_ell (double mj, double *ret);
+static void chap_trans (double mj, double *ret);
+static void planpos (double mj, int obj, double prec, double *ret);
 
 /* coordinate transformation
@@ -21,7 +20,7 @@
  */
 static void
-chap_trans (mjd, ret)
-double mjd;	/* destination epoch */
-double *ret;	/* vector to be transformed _IN PLACE_ */
+chap_trans (
+double mj,	/* destination epoch */
+double *ret)	/* vector to be transformed _IN PLACE_ */
 {
 	double ra, dec, r, eps;
@@ -29,6 +28,6 @@
 
 	cartsph(ret[0], ret[1], ret[2], &ra, &dec, &r);
-	precess(J2000, mjd, &ra, &dec);
-	obliquity(mjd, &eps);
+	precess(J2000, mj, &ra, &dec);
+	obliquity(mj, &eps);
 	sr = sin(ra); cr = cos(ra);
 	sd = sin(dec); cd = cos(dec);
@@ -43,7 +42,7 @@
  */
 static void
-pluto_ell (mjd, ret)
-double mjd;	/* epoch */
-double *ret;	/* ecliptic coordinates {l,b,r} at equinox of date */
+pluto_ell (
+double mj,	/* epoch */
+double *ret)	/* ecliptic coordinates {l,b,r} at equinox of date */
 {
 	/* mean orbital elements of Pluto.
@@ -55,6 +54,6 @@
 		Om0 = 110.307,			/* long asc node, deg */
 		omeg0 = 113.768,		/* arg of perihel, deg */
-		mjdp = 2448045.539 - MJD0,	/* epoch of perihel */
-		mjdeq = J2000,			/* equinox of elements */
+		mjp = 2448045.539 - MJD0,	/* epoch of perihel */
+		mjeq = J2000,			/* equinox of elements */
 		n = 144.9600/36525.;            /* daily motion, deg */
 
@@ -63,7 +62,7 @@
 	double lo, slo, clo;	/* longitude in orbit from asc node */
 
-	reduce_elements(mjdeq, mjd, degrad(inc0), degrad(omeg0), degrad(Om0),
+	reduce_elements(mjeq, mj, degrad(inc0), degrad(omeg0), degrad(Om0),
 				&inc, &omeg, &Om);
-	ma = degrad((mjd - mjdp) * n);
+	ma = degrad((mj - mjp) * n);
 	anomaly(ma, e, &nu, &ea);
 	ret[2] = a * (1.0 - e*cos(ea));			/* r */
@@ -81,22 +80,18 @@
  */
 static void
-planpos (mjd, obj, prec, ret)
-double mjd;
-int obj;
-double prec;
-double *ret;
-{
-	if (mjd >= CHAP_BEGIN && mjd <= CHAP_END) {
+planpos (double mj, int obj, double prec, double *ret)
+{
+	if (mj >= CHAP_BEGIN && mj <= CHAP_END) {
 	    if (obj >= JUPITER) {		/* prefer Chapront */
-		chap95(mjd, obj, prec, ret);
-		chap_trans (mjd, ret);
+		chap95(mj, obj, prec, ret);
+		chap_trans (mj, ret);
 	    } else {				/* VSOP for inner planets */
-		vsop87(mjd, obj, prec, ret);
+		vsop87(mj, obj, prec, ret);
 	    }
 	} else {				/* outside Chapront time: */
 	    if (obj != PLUTO) {			/* VSOP for all but Pluto */
-		vsop87(mjd, obj, prec, ret);
+		vsop87(mj, obj, prec, ret);
 	    } else {				/* Pluto mean elliptic orbit */
-		pluto_ell(mjd, ret);
+		pluto_ell(mj, ret);
 	    }
 	}
@@ -126,5 +121,5 @@
 };
 
-/* given a modified Julian date, mjd, and a planet, p, find:
+/* given a modified Julian date, mj, and a planet, p, find:
  *   lpd0: heliocentric longitude, 
  *   psi0: heliocentric latitude,
@@ -148,10 +143,8 @@
  */
 void
-plans (mjd, p, lpd0, psi0, rp0, rho0, lam, bet, dia, mag)
-double mjd;
-int p;
-double *lpd0, *psi0, *rp0, *rho0, *lam, *bet, *dia, *mag;
-{
-	static double lastmjd = -10000;
+plans (double mj, PLCode p, double *lpd0, double *psi0, double *rp0,
+double *rho0, double *lam, double *bet, double *dia, double *mag)
+{
+	static double lastmj = -10000;
 	static double lsn, bsn, rsn;	/* geocentric coords of sun */
 	static double xsn, ysn, zsn;	/* cartesian " */
@@ -163,12 +156,12 @@
 	int pass;
 
-	/* get sun cartesian; needed only once at mjd */
-	if (mjd != lastmjd) {
-	    sunpos (mjd, &lsn, &rsn, &bsn);
+	/* get sun cartesian; needed only once at mj */
+	if (mj != lastmj) {
+	    sunpos (mj, &lsn, &rsn, &bsn);
 	    sphcart (lsn, bsn, rsn, &xsn, &ysn, &zsn);
-            lastmjd = mjd;
+            lastmj = mj;
         }
 
-	/* first find the true position of the planet at mjd.
+	/* first find the true position of the planet at mj.
 	 * then repeat a second time for a slightly different time based
 	 * on the position found in the first pass to account for light-travel
@@ -183,5 +176,5 @@
 	     * alternative option:  vsop allows calculating rates.
 	     */
-	    planpos(mjd - dt, p, 0.0, ret);
+	    planpos(mj - dt, p, 0.0, ret);
 
 	    lp = ret[0];
@@ -225,5 +218,5 @@
 	if (p == SATURN) {
 	    double et, st, set;
-	    satrings (bp, lp, rp, lsn+PI, rsn, mjd+MJD0, &et, &st);
+	    satrings (bp, lp, rp, lsn+PI, rsn, mj+MJD0, &et, &st);
 	    set = sin(fabs(et));
 	    *mag += (-2.60 + 1.25*set)*set;
@@ -232,3 +225,3 @@
 
 /* For RCS Only -- Do Not Edit */
-static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: plans.c,v $ $Date: 2001-10-22 12:08:27 $ $Revision: 1.2 $ $Name: not supported by cvs2svn $"};
+static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: plans.c,v $ $Date: 2004-06-15 16:52:39 $ $Revision: 1.3 $ $Name: not supported by cvs2svn $"};
Index: /trunk/SophyaExt/XephemAstroLib/plmoon.c
===================================================================
--- /trunk/SophyaExt/XephemAstroLib/plmoon.c	(revision 2551)
+++ /trunk/SophyaExt/XephemAstroLib/plmoon.c	(revision 2551)
@@ -0,0 +1,294 @@
+/* compute Obj fields for natural satellites.
+ */
+
+#include <stdio.h>
+#include <string.h>
+#include <math.h>
+
+#include "astro.h"
+
+/* private cache of planet ephemerides and when they were computed
+ * N.B. don't use ones in builtin[] -- they are the user's responsibility.
+ */
+static ObjPl plobj[NOBJ];
+static Now plnow[NOBJ];
+
+/* public builtin storage
+ */
+static Obj builtin[NBUILTIN];
+
+static char *moondir;
+
+static void setMoon (Now *np, Obj *moonop, Obj *planop, MoonData *mdp);
+static void init1BI (int idx, int pl, int moon, char *name);
+static void initPlobj(void);
+static void initDir(void);
+static void rotate (double a, double *x, double *y);
+
+/* directory in which to look for auxil moon data files.
+ * N.B. caller must supply persistent storage.
+ */
+void
+setMoonDir (char *dir)
+{
+	moondir = dir;
+}
+
+/* return set of builtin objects.
+ * caller can use this storage but should never try to free anything.
+ */
+int
+getBuiltInObjs (Obj **opp)
+{
+	if (!builtin[MERCURY].o_name[0]) {
+	    /* first time only */
+
+	    init1BI (MERCURY,   MERCURY, X_PLANET,    "Mercury");
+
+	    init1BI (VENUS,     VENUS,   X_PLANET,    "Venus");
+
+	    init1BI (MARS,      MARS,    X_PLANET,    "Mars");
+	    init1BI (PHOBOS,    MARS,    M_PHOBOS,    "Phobos");
+	    init1BI (DEIMOS,    MARS,    M_DEIMOS,    "Deimos");
+
+	    init1BI (JUPITER,   JUPITER, X_PLANET,    "Jupiter");
+	    init1BI (IO,        JUPITER, J_IO,        "Io");
+	    init1BI (EUROPA,    JUPITER, J_EUROPA,    "Europa");
+	    init1BI (GANYMEDE,  JUPITER, J_GANYMEDE,  "Ganymede");
+	    init1BI (CALLISTO,  JUPITER, J_CALLISTO,  "Callisto");
+
+	    init1BI (SATURN,    SATURN,  X_PLANET,    "Saturn");
+	    init1BI (MIMAS,     SATURN,  S_MIMAS,     "Mimas");
+	    init1BI (ENCELADUS, SATURN,  S_ENCELADUS, "Enceladus");
+	    init1BI (TETHYS,    SATURN,  S_TETHYS,    "Tethys");
+	    init1BI (DIONE,     SATURN,  S_DIONE,     "Dione");
+	    init1BI (RHEA,      SATURN,  S_RHEA,      "Rhea");
+	    init1BI (TITAN,     SATURN,  S_TITAN,     "Titan");
+	    init1BI (HYPERION,  SATURN,  S_HYPERION,  "Hyperion");
+	    init1BI (IAPETUS,   SATURN,  S_IAPETUS,   "Iapetus");
+
+	    init1BI (URANUS,    URANUS,  X_PLANET,    "Uranus");
+	    init1BI (ARIEL,     URANUS,  U_ARIEL,     "Ariel");
+	    init1BI (UMBRIEL,   URANUS,  U_UMBRIEL,   "Umbriel");
+	    init1BI (TITANIA,   URANUS,  U_TITANIA,   "Titania");
+	    init1BI (OBERON,    URANUS,  U_OBERON,    "Oberon");
+	    init1BI (MIRANDA,   URANUS,  U_MIRANDA,   "Miranda");
+
+	    init1BI (NEPTUNE,   NEPTUNE, X_PLANET,    "Neptune");
+
+	    init1BI (PLUTO,     PLUTO,   X_PLANET,    "Pluto");
+
+	    init1BI (SUN,       SUN,     X_PLANET,    "Sun");
+
+	    init1BI (MOON,      MOON,    X_PLANET,    "Moon");
+	}
+
+	*opp = builtin;
+	return (NBUILTIN);
+}
+
+static void
+init1BI (int idx, int pl, int moon, char *name)
+{
+	strcpy (builtin[idx].o_name, name);
+	builtin[idx].o_type = PLANET;
+	builtin[idx].pl_code = pl;
+	builtin[idx].pl_moon = moon;
+}
+
+/* find the circumstances for natural satellite object op at np.
+ * TODO: distances and helio coords just copied from parent planet.
+ */
+int
+plmoon_cir (Now *np, Obj *moonop)
+{
+	Obj *sunop = (Obj*)&plobj[SUN];
+	MoonData md[X_MAXNMOONS];
+	double sz, t1, t2;
+	MoonData *mdp;
+	Obj *planop;
+
+	/* init plobj[] */
+	if (!((Obj *)&plobj[0])->o_type) {
+	    initPlobj();
+	    initDir();
+	}
+
+	/* get sun @ np */
+	if (memcmp (&plnow[SUN], np, sizeof(Now))) {
+	    obj_cir (np, (Obj*)&plobj[SUN]);
+	    memcpy (&plnow[SUN], np, sizeof(Now));
+	}
+
+	/* get parent planet and moon info @ np */
+	switch (moonop->pl_code) {
+
+	case MARS:
+	case PHOBOS:
+	case DEIMOS:
+
+	    planop = (Obj*)&plobj[MARS];
+
+	    if (memcmp (&plnow[MARS], np, sizeof(Now))) {
+		obj_cir (np, planop);
+		memcpy (&plnow[MARS], np, sizeof(Now));
+	    }
+
+	    /* don't worry, this already caches based on same mjd */
+	    marsm_data (mjd, moondir, sunop, planop, &sz, md);
+	    mdp = &md[moonop->pl_moon];
+	    break;
+
+	case JUPITER:
+	case IO:
+	case EUROPA:
+	case GANYMEDE:
+	case CALLISTO:
+
+	    planop = (Obj*)&plobj[JUPITER];
+
+	    if (memcmp (&plnow[JUPITER], np, sizeof(Now))) {
+		obj_cir (np, planop);
+		memcpy (&plnow[JUPITER], np, sizeof(Now));
+	    }
+
+	    /* don't worry, this already caches based on same mjd */
+	    jupiter_data (mjd, moondir, sunop, planop, &sz, &t1, &t2, md);
+	    mdp = &md[moonop->pl_moon];
+	    moonop->pl_aux1 = t1;
+	    moonop->pl_aux2 = t2;
+	    break;
+
+	case SATURN:
+	case MIMAS:
+	case ENCELADUS:
+	case TETHYS:
+	case DIONE:
+	case RHEA:
+	case TITAN:
+	case HYPERION:
+	case IAPETUS:
+
+	    planop = (Obj*)&plobj[SATURN];
+
+	    if (memcmp (&plnow[SATURN], np, sizeof(Now))) {
+		obj_cir (np, planop);
+		memcpy (&plnow[SATURN], np, sizeof(Now));
+	    }
+
+	    /* don't worry, this already caches based on same mjd */
+	    saturn_data (mjd, moondir, sunop, planop, &sz, &t1, &t2, md);
+	    mdp = &md[moonop->pl_moon];
+	    moonop->pl_aux1 = t1;
+	    moonop->pl_aux2 = t2;
+	    break;
+
+	case URANUS:
+	case ARIEL:
+	case UMBRIEL:
+	case TITANIA:
+	case OBERON:
+	case MIRANDA:
+
+	    planop = (Obj*)&plobj[URANUS];
+
+	    if (memcmp (&plnow[URANUS], np, sizeof(Now))) {
+		obj_cir (np, planop);
+		memcpy (&plnow[URANUS], np, sizeof(Now));
+	    }
+
+	    /* don't worry, this already caches based on same mjd */
+	    uranus_data (mjd, moondir, sunop, planop, &sz, md);
+	    mdp = &md[moonop->pl_moon];
+	    break;
+
+	default:
+
+	    printf ("Called plmoon_cir with bad code: %d\n",moonop->pl_code);
+	    return (-1);
+
+	}
+
+	/* set moonop */
+	setMoon (np, moonop, planop, mdp);
+
+	return (0);
+}
+
+static void
+initPlobj()
+{
+	int i;
+
+	for (i = 0; i < NOBJ; i++) {
+	    ((Obj*)&plobj[i])->o_type = PLANET;
+	    ((Obj*)&plobj[i])->pl_code = i;
+	}
+}
+
+/* install a default if no moondir set yet */
+static void
+initDir()
+{
+	if (!moondir)
+	    moondir = ".";
+}
+
+/* set moonop->s_* fields.
+ * np is needed to get local parallactic angle.
+ */
+static void
+setMoon (Now *np, Obj *moonop, Obj *planop, MoonData *mdp)
+{
+	double pa, dra, ddec;
+
+	/* just copy most fields from planet for now */
+	moonop->s_gaera = planop->s_gaera;	/* TODO */
+	moonop->s_gaedec = planop->s_gaedec;	/* TODO */
+	moonop->s_elong = planop->s_elong;	/* TODO */
+	moonop->s_size = 0;			/* TODO */
+	moonop->s_sdist = planop->s_sdist;	/* TODO */
+	moonop->s_edist = planop->s_edist;	/* TODO */
+	moonop->s_hlat = planop->s_hlat;	/* TODO */
+	moonop->s_hlong = planop->s_hlong;	/* TODO */
+	moonop->s_phase = planop->s_phase;	/* TODO */
+
+	/* new ra/dec directly from mdp */
+	moonop->s_ra = mdp->ra;
+	moonop->s_dec = mdp->dec;
+
+	/* geoemtry info */
+	moonop->pl_x = mdp->x;
+	moonop->pl_y = mdp->y;
+	moonop->pl_z = mdp->z;
+	moonop->pl_evis = mdp->evis;
+	moonop->pl_svis = mdp->svis;
+
+	/* tweak alt/az by change in ra/dec rotated by pa */
+	pa = parallacticLDA (lat, planop->s_dec, planop->s_alt);
+	if (planop->s_az < PI)
+	    pa = -pa;			/* rotation radec to altaz */
+	dra = (moonop->s_ra - planop->s_ra)*cos(planop->s_dec);
+	ddec = moonop->s_dec - planop->s_dec;
+	rotate (pa, &dra, &ddec);
+	moonop->s_alt = planop->s_alt + ddec;
+	moonop->s_az = planop->s_az - dra/cos(planop->s_alt);
+
+	/* new mag directly from mdp */
+	set_smag (moonop, mdp->mag);
+
+	/* name */
+	strcpy (moonop->o_name, mdp->full);
+}
+
+/* rotate ccw by a */
+static void
+rotate (double a, double *x, double *y)
+{
+	double sa = sin(a);
+	double ca = cos(a);
+	double xp = (*x)*ca - (*y)*sa;
+	double yp = (*x)*sa + (*y)*ca;
+	*x = xp;
+	*y = yp;
+}
Index: /trunk/SophyaExt/XephemAstroLib/riset.c
===================================================================
--- /trunk/SophyaExt/XephemAstroLib/riset.c	(revision 2550)
+++ /trunk/SophyaExt/XephemAstroLib/riset.c	(revision 2551)
@@ -2,9 +2,8 @@
 #include <math.h>
 
-#include "P_.h"
 #include "astro.h"
 
 /* given the true geocentric ra and dec of an object, the observer's latitude,
- *   lat, and a horizon displacement correction, dis, all in radians, find the
+ *   lt, and a horizon displacement correction, dis, all in radians, find the
  *   local sidereal times and azimuths of rising and setting, lstr/s
  *   and azr/s, also all in radians, respectively.
@@ -25,10 +24,6 @@
  */
 void
-riset (ra, dec, lat, dis, lstr, lsts, azr, azs, status)
-double ra, dec;
-double lat, dis;
-double *lstr, *lsts;
-double *azr, *azs;
-int *status;
+riset (double ra, double dec, double lt, double dis, double *lstr,
+double *lsts, double *azr, double *azs, int *status)
 {
 #define	EPS	(1e-9)	/* math rounding fudge - always the way, eh? */
@@ -40,7 +35,7 @@
 	int shemi;		/* flag for southern hemisphere reflection */
 
-	/* reflect lat and dec if in southern hemisphere, then az back later */
-	if ((shemi= (lat < 0.)) != 0) {
-	    lat = -lat;
+	/* reflect lt and dec if in southern hemisphere, then az back later */
+	if ((shemi= (lt < 0.)) != 0) {
+	    lt = -lt;
 	    dec = -dec;
 	}
@@ -48,6 +43,6 @@
 	/* establish zenith angle, and its extrema */
 	z = (PI/2.) + dis;
-	zmin = fabs (dec - lat);
-	zmax = PI - fabs(dec + lat);
+	zmin = fabs (dec - lt);
+	zmax = PI - fabs(dec + lt);
 
 	/* first consider special cases.
@@ -64,5 +59,5 @@
 
 	/* compute rising hour angle -- beware found off */
-	cos_h = (cos(z)-sin(lat)*sin(dec))/(cos(lat)*cos(dec));
+	cos_h = (cos(z)-sin(lt)*sin(dec))/(cos(lt)*cos(dec));
 	if (cos_h >= 1.)
 	    h =  0.;
@@ -73,5 +68,5 @@
 
 	/* compute setting azimuth -- beware found off */
-	xaz = sin(dec)*cos(lat)-cos(dec)*cos(h)*sin(lat);
+	xaz = sin(dec)*cos(lt)-cos(dec)*cos(h)*sin(lt);
 	yaz = -1.*cos(dec)*sin(h);
 	if (xaz == 0.) {
@@ -103,3 +98,3 @@
 
 /* For RCS Only -- Do Not Edit */
-static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: riset.c,v $ $Date: 2001-10-22 12:08:28 $ $Revision: 1.2 $ $Name: not supported by cvs2svn $"};
+static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: riset.c,v $ $Date: 2004-06-15 16:52:40 $ $Revision: 1.3 $ $Name: not supported by cvs2svn $"};
Index: /trunk/SophyaExt/XephemAstroLib/riset_cir.c
===================================================================
--- /trunk/SophyaExt/XephemAstroLib/riset_cir.c	(revision 2550)
+++ /trunk/SophyaExt/XephemAstroLib/riset_cir.c	(revision 2551)
@@ -3,20 +3,16 @@
 #include <stdio.h>
 #include <math.h>
-#if defined(__STDC__)
 #include <stdlib.h>
 #include <string.h>
-#endif
-
-#include "P_.h"
+
 #include "astro.h"
-#include "circum.h"
 
 #define	TMACC	(10./3600./24.0)	/* convergence accuracy, days */
 
-static void e_riset_cir P_((Now *np, Obj *op, double dis, RiseSet *rp));
-static int find_0alt P_((double dt, double dis, Now *np, Obj *op));
-static int find_transit P_((double dt, Now *np, Obj *op));
-static int find_max P_((Now *np, Obj *op, double tr, double ts, double *tp,
-    double *alp));
+static void e_riset_cir (Now *np, Obj *op, double dis, RiseSet *rp);
+static int find_0alt (double dt, double dis, Now *np, Obj *op);
+static int find_transit (double dt, Now *np, Obj *op);
+static int find_max (Now *np, Obj *op, double tr, double ts, double *tp,
+    double *alp);
 
 /* find where and when an object, op, will rise and set and
@@ -26,9 +22,5 @@
  */
 void
-riset_cir (np, op, dis, rp)
-Now *np;
-Obj *op;
-double dis;
-RiseSet *rp;
+riset_cir (Now *np, Obj *op, double dis, RiseSet *rp)
 {
 	double mjdn;	/* mjd of local noon */
@@ -64,6 +56,6 @@
 	/* first approximation is to find rise/set times of a fixed object
 	 * at the current epoch in its position at local noon.
-	 * N.B. add typical refraction for initial go/no-go test. if it
-	 *   passes, real code does refraction rigorously.
+	 * N.B. add typical refraction if dis is above horizon for initial
+	 *   go/no-go test. if it passes, real code does refraction rigorously.
 	 */
 	n.n_mjd = mjdn;
@@ -73,5 +65,6 @@
 	}
 	ran = o.s_gaera;
-	riset (o.s_gaera, o.s_gaedec, lat, dis+.01, &lr, &ls, &ar, &as, &rss);
+	riset (o.s_gaera, o.s_gaedec, lat, dis+(dis>.01 ? 0 : .01), &lr, &ls,
+								&ar, &as, &rss);
 	switch (rss) {
 	case  0:  break;
@@ -133,15 +126,12 @@
  */
 void
-twilight_cir (np, dis, dawn, dusk, status)
-Now *np;
-double dis;
-double *dawn, *dusk;
-int *status;
+twilight_cir (Now *np, double dis, double *dawn, double *dusk, int *status)
 {
 	RiseSet rs;
 	Obj o;
 
+	memset (&o, 0, sizeof(o));
 	o.o_type = PLANET;
-	o.pl.pl_code = SUN;
+	o.pl_code = SUN;
 	(void) strcpy (o.o_name, "Sun");
 	riset_cir (np, &o, dis, &rs);
@@ -160,9 +150,5 @@
  */
 static void
-e_riset_cir (np, op, dis, rp)
-Now *np;
-Obj *op;
-double dis;
-RiseSet *rp;
+e_riset_cir (Now *np, Obj *op, double dis, RiseSet *rp)
 {
 #define	DEGSTEP	5		/* time step is about this many degrees */
@@ -272,9 +258,9 @@
  */
 static int
-find_0alt (dt, dis, np, op)
-double dt;	/* hours from noon to first guess at event */
-double dis;	/* horizon displacement, rads */
-Now *np;	/* working Now -- starts with mjd is noon, returns as answer */
-Obj *op;	/* working object -- returns as answer */
+find_0alt (
+double dt,	/* hours from noon to first guess at event */
+double dis,	/* horizon displacement, rads */
+Now *np,	/* working Now -- starts with mjd is noon, returns as answer */
+Obj *op)	/* working object -- returns as answer */
 {
 #define	MAXPASSES	20		/* max iterations to try */
@@ -286,8 +272,10 @@
 
 	/* insure initial guess is today -- if not, move by 24 hours */
-	if (dt < -12.0)
-	    dt += 24.0;
-	if (dt > 12.0)
-	    dt -= 24.0;
+	if (dt < -12.0 && !find_0alt (dt+24, dis, np, op))
+	    return (0);
+	mjd = mjdn;
+	if (dt > 12.0 && !find_0alt (dt-24, dis, np, op))
+	    return (0);
+	mjd = mjdn;
 	
 	/* convert dt to days for remainder of algorithm */
@@ -325,8 +313,5 @@
  */
 static int
-find_transit (dt, np, op)
-double dt;
-Now *np;
-Obj *op;
+find_transit (double dt, Now *np, Obj *op)
 {
 #define	MAXLOOPS	10
@@ -370,9 +355,9 @@
  */
 static int
-find_max (np, op, tr, ts, tp, alp)
-Now *np;
-Obj *op;
-double tr, ts;		/* times of rise and set */
-double *tp, *alp;	/* time of max altitude, and that altitude */
+find_max (
+Now *np,
+Obj *op,
+double tr, double ts,		/* times of rise and set */
+double *tp, double *alp)	/* time of max altitude, and that altitude */
 {
 	mjd = (ts + tr)/2;
@@ -385,3 +370,3 @@
 
 /* For RCS Only -- Do Not Edit */
-static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: riset_cir.c,v $ $Date: 2001-10-22 12:08:28 $ $Revision: 1.2 $ $Name: not supported by cvs2svn $"};
+static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: riset_cir.c,v $ $Date: 2004-06-15 16:52:40 $ $Revision: 1.3 $ $Name: not supported by cvs2svn $"};
